#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef struct P {
    float x, y;
    struct P *next;
} Punto;

typedef Punto *Poligono;

typedef struct S {
    Poligono lisP;
    struct S *next;
} Pol;

typedef Pol *ListaPoligoni;

ListaPoligoni costruisci();
Poligono InsInFondoPunto(Poligono lista,float x,float y);
ListaPoligoni InsInFondoPoligono( ListaPoligoni lista,Poligono lis );
void VisualizzaPoligono(Poligono lista );
void VisualizzaListaPoligoni(ListaPoligoni lista );
ListaPoligoni Cancella( ListaPoligoni lista, ListaPoligoni elem );
void DistruggiListaRic ( Poligono lista );
float calcolaPerimetro(Poligono poligono);
float calcolaMediaPerimetri(ListaPoligoni lista);

float calcolaPerimetro(Poligono poligono) {
    float perimetro = 0.0;
    Punto *current = poligono;

    while (current != NULL && current->next != NULL) {
        perimetro += sqrt(pow(current->x - current->next->x, 2) + pow(current->y - current->next->y, 2));
        current = current->next;
    }

    // Aggiungi il lato finale per chiudere il poligono
    if (current != NULL && poligono != NULL) {
        perimetro += sqrt(pow(current->x - poligono->x, 2) + pow(current->y - poligono->y, 2));
    }

    return perimetro;
}

float calcolaMediaPerimetri(ListaPoligoni lista) {
    int numPoligoni = 0;
    float sommaPerimetri = 0.0;
    Pol *current = lista;

    while (current != NULL) {
        float perimetro = calcolaPerimetro(current->lisP);
        sommaPerimetri += perimetro;
        numPoligoni++;
        current = current->next;
    }

    if (numPoligoni > 0) {
        return sommaPerimetri / numPoligoni;
    } else {
        return 0.0; // Nessun poligono nella lista
    }
}

ListaPoligoni Cancella( ListaPoligoni lista, ListaPoligoni elem ) {
    ListaPoligoni puntTemp;
	if( lista!=NULL)
	    if( lista == elem ) {
		    puntTemp = lista->next;
			free( lista );
			return puntTemp; // per cancellare tutte le istanze: return Cancella(PuntTemp, Elem);
        }
		else
		    lista->next = Cancella( lista->next, elem );
		return lista;
}
//Chiamata : lista1 = Cancella( lista1, elemento );

void DistruggiListaRic ( Poligono lista ) {
    if ( lista!=NULL ) {
	    DistruggiListaRic( lista->next ); free( lista );
	}
}

ListaPoligoni eliminaPoligoniSottoMedia(ListaPoligoni lista) {
    ListaPoligoni temp,cur = lista;
    float mediaPerimetri = calcolaMediaPerimetri(lista);
    
    while (cur != NULL) {
        if (calcolaPerimetro(cur->lisP) < mediaPerimetri) {
            temp=cur->next;
            printf("Cancello lista: ");
            VisualizzaPoligono(cur->lisP);
            DistruggiListaRic(cur->lisP); 
            lista=Cancella(lista,cur);
            cur=temp;
        } else {
            cur = cur->next;
        }
    }
    printf("\n");
    return lista;
}


int main() {
    // Creazione di una lista di poligoni di esempio
    ListaPoligoni lista=costruisci();

    printf("Lista iniziale:\n");
    VisualizzaListaPoligoni(lista);

    float mediaPerimetri = calcolaMediaPerimetri(lista);
    printf("Media dei perimetri: %.2f\n", mediaPerimetri);

    lista=eliminaPoligoniSottoMedia(lista);

    printf("Lista dopo l'eliminazione dei poligoni con perimetro sotto la media:\n");
    VisualizzaListaPoligoni(lista);

    return 0;
}

ListaPoligoni costruisci(){
	int M[5][10]={0,0,1,0,2,2,1,1,-1,-1,
	              1,6,9,1,5,5,1,9,0,8,
				  1,3,1,4,4,4,4,2,3,1,
				  1,3,2,4,0,2,0,0,-1,-1,
				  1,32,8,8,5,0,-1,-1,-1,-1};
	int i,k;ListaPoligoni ris=NULL; Poligono temp=NULL;
	for(i=0;i<5;i++){
		temp=NULL;for(k=0;k<10;k=k+2)if(M[i][k]!=-1)temp=InsInFondoPunto(temp,M[i][k],M[i][k+1]);
		ris=InsInFondoPoligono(ris,temp);}
	return ris;
}


Poligono InsInFondoPunto(Poligono lista,float x,float y) {
    Poligono punt;
    if(lista==NULL) { punt = (Poligono)malloc( sizeof(Punto) );
                     punt->next = NULL; punt->x = x; punt->y = y; return  punt;
    }else{lista->next = InsInFondoPunto(lista->next,x,y); return lista;}
}

ListaPoligoni InsInFondoPoligono( ListaPoligoni lista,Poligono lis ) {
   ListaPoligoni punt;
   if(lista==NULL) { punt = (ListaPoligoni)malloc( sizeof(Pol) );
                     punt->next=NULL; punt->lisP=lis; return  punt;
   }else{lista->next = InsInFondoPoligono(lista->next,lis); return lista;}
}

void VisualizzaPoligono(Poligono lista ){
    if (lista==NULL) printf(" ---| \n");
    else{printf(" (%.2f,%.2f) ---> ", lista->x, lista->y); VisualizzaPoligono( lista->next );}
}

void VisualizzaListaPoligoni(ListaPoligoni lista ) {
    if(lista==NULL) printf("\n");
    else{VisualizzaPoligono(lista->lisP); VisualizzaListaPoligoni(lista->next);}
}

